## Grid Layout

### Basic Usage

```Python
from tensorpc.flow import (marker, mui,
                           plotly, plus, three, UserObjTree)

class TestNodeNode0(UserObjTree):

    def __init__(self) -> None:
        super().__init__()

    @marker.mark_create_preview_layout
    def layout_func(self):
        return mui.VBox([mui.Button("WTF"), mui.Markdown("## 6")])


class TestNodeRoot(UserObjTree):

    def __init__(self) -> None:
        super().__init__()
        self.node0 = TestNodeNode0()
        self._childs["node0"] = self.node0

    @marker.mark_create_preview_layout
    def layout_func(self):
        return mui.VBox([mui.Button("ROOT"), mui.Markdown("## ROOT132")])


class App:

    @marker.mark_create_layout
    def my_layout(self):
        root = TestNodeRoot()
        return mui.HBox([
            plus.GridPreviewLayout({
                "root": root,
                "root.node0": root.get_childs()["node0"]
            })
        ]).prop(width="100%")

```
